# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`nsswitch`](#nsswitch): Manages the system nsswitch.conf configuration

## Classes

### <a name="nsswitch"></a>`nsswitch`

This module creates a `nsswitch.conf` file with all the lines that determine
the sources from which to obtain name-service information in a range of
categories, and in what order.

* **See also**
  * nsswitch.conf(5)

#### Examples

##### Basic example

```puppet
include nsswitch

class { 'nsswitch':
  passwd => ['ldap','files'],
  hosts  => ['dns [!UNAVAIL=return]','files'],
}
```

#### Parameters

The following parameters are available in the `nsswitch` class:

* [`aliases`](#-nsswitch--aliases)
* [`automount`](#-nsswitch--automount)
* [`bootparams`](#-nsswitch--bootparams)
* [`ethers`](#-nsswitch--ethers)
* [`group`](#-nsswitch--group)
* [`gshadow`](#-nsswitch--gshadow)
* [`hosts`](#-nsswitch--hosts)
* [`netgroup`](#-nsswitch--netgroup)
* [`netmasks`](#-nsswitch--netmasks)
* [`networks`](#-nsswitch--networks)
* [`passwd`](#-nsswitch--passwd)
* [`protocols`](#-nsswitch--protocols)
* [`publickey`](#-nsswitch--publickey)
* [`rpc`](#-nsswitch--rpc)
* [`services`](#-nsswitch--services)
* [`shadow`](#-nsswitch--shadow)
* [`shells`](#-nsswitch--shells)
* [`sudoers`](#-nsswitch--sudoers)
* [`subid`](#-nsswitch--subid)
* [`file_path`](#-nsswitch--file_path)
* [`file_group`](#-nsswitch--file_group)
* [`file_owner`](#-nsswitch--file_owner)
* [`file_perms`](#-nsswitch--file_perms)

##### <a name="-nsswitch--aliases"></a>`aliases`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Mail aliases, used by getaliasent() and related functions.

Default value: `undef`

##### <a name="-nsswitch--automount"></a>`automount`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Which conventions to use for automounting of homes.

Default value: `undef`

##### <a name="-nsswitch--bootparams"></a>`bootparams`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Where bootparams shall be supplied from (e.g. for diskless clients at boot
time using rpc.bootparamd).

Default value: `undef`

##### <a name="-nsswitch--ethers"></a>`ethers`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Ethernet numbers.

Default value: `undef`

##### <a name="-nsswitch--group"></a>`group`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Groups of users, used by getgrent() and related functions.

Default value: `undef`

##### <a name="-nsswitch--gshadow"></a>`gshadow`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Shadow groups, used by getspnam() and related functions.

Default value: `undef`

##### <a name="-nsswitch--hosts"></a>`hosts`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Host names and numbers, used by gethostbyname() and related functions.

Default value: `undef`

##### <a name="-nsswitch--netgroup"></a>`netgroup`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Network-wide list of hosts and users, used for access rules.

Default value: `undef`

##### <a name="-nsswitch--netmasks"></a>`netmasks`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Netmasks specify how much of the address to reserve for sub-dividing
networks into subnetworks.

Default value: `undef`

##### <a name="-nsswitch--networks"></a>`networks`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Network names and numbers, used by getnetent() and related functions.

Default value: `undef`

##### <a name="-nsswitch--passwd"></a>`passwd`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

User passwords, used by getpwent() and related functions.

Default value: `undef`

##### <a name="-nsswitch--protocols"></a>`protocols`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Network protocols, used by getprotoent() and related functions.

Default value: `undef`

##### <a name="-nsswitch--publickey"></a>`publickey`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Public and secret keys for Secure_RPC used by NFS and NIS+.

Default value: `undef`

##### <a name="-nsswitch--rpc"></a>`rpc`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Remote procedure call names and numbers, used by getrpcbyname() and related
functions.

Default value: `undef`

##### <a name="-nsswitch--services"></a>`services`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Network services, used by getservent() and related functions.

Default value: `undef`

##### <a name="-nsswitch--shadow"></a>`shadow`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Shadow user passwords, used by getspnam() and related functions.

Default value: `undef`

##### <a name="-nsswitch--shells"></a>`shells`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Valid user shells, used by getusershell() and related functions.

Default value: `undef`

##### <a name="-nsswitch--sudoers"></a>`sudoers`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

Sudoers policy module users.

Default value: `undef`

##### <a name="-nsswitch--subid"></a>`subid`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`

subuid and subgid mapping

Default value: `undef`

##### <a name="-nsswitch--file_path"></a>`file_path`

Data type: `Stdlib::Unixpath`

The path to `nsswitch.conf` on the system.

Default value: `'/etc/nsswitch.conf'`

##### <a name="-nsswitch--file_group"></a>`file_group`

Data type: `String[1]`

Group of the nsswitch.conf file

Default value: `'root'`

##### <a name="-nsswitch--file_owner"></a>`file_owner`

Data type: `String[1]`

Owner of the nsswitch.conf file

Default value: `'root'`

##### <a name="-nsswitch--file_perms"></a>`file_perms`

Data type: `Stdlib::Filemode`

Permissions for the nsswitch.conf file

Default value: `'0644'`

